/*
    Prank for Hurd 0.401

    Copyright (C) 2011  Samuel Thibault <samuel.thibault@gnu.org>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "head.S"

#define VGA 0xb8000
#define PATH_MAX 42
#define COMMAND_SIZE PATH_MAX
#define STACK_SIZE 0x10000

// function parameters are in %ecx, %edx, %eax

main:
// Initialize stack
	movl $(stack + STACK_SIZE),%esp
	movl %esp,%ebp

	inb $0x60,%al
	movb %al,lastk

	movl $welcome,%ecx
	call putstring

prompt:
	movb $'#',%cl
	call putchar
	movb $' ',%cl
	call putchar
	movb $0,cmdp
	movb $1,cmdr

loop:

// Yes, quick & dirty as hell! :)
	inb $0x60,%al
	cmpb lastk,%al
	je loop
	movb %al,lastk

# shifts
	cmpb $0x2a,%al
	jne 1f
	movb $1,shiftl
	jmp loop
1:
	cmpb $0xaa,%al
	jne 1f
	movb $0,shiftl
	jmp loop
1:
	cmpb $0x36,%al
	jne 1f
	movb $1,shiftl
	jmp loop
1:
	cmpb $0xb6,%al
	jne 1f
	movb $0,shiftl
	jmp loop
1:

# from now on, ignore releases
	testb $0x80,%al
	jz loop
	xorb  $0x80,%al

# enter
	cmpb $28,%al
	jne 1f
	call newline
	movl cmdp,%ebx
	movb $0,cmd(%ebx)
	movl $cmd,%ecx
	call putstring
	movl $cbf,%ecx
	call putstring
	jmp prompt
1:

# backspace
	cmpb $14,%al
	jne 1f
	cmpl $0,cur
	jz loop
	cmpl $0,X
	jz apff
	decl X
	jmp notapff
apff:
	movl $79,X
notapff:
	decl cur
	movl $VGA,%eax
	addl cur,%eax
	addl cur,%eax
	movb $0,(%eax)
	movw cur,%cx
	call cursor
	jmp loop
1:

# F1
	cmpb $59,%al
	jl 1f
	cmpb $68,%al
	jg 1f
	call newline
	movl $help,%ecx
	call putstring
	jmp prompt
1:

# hurd
	cmpb $91,%al
	jne 1f
	call newline
	movl $hurd,%ecx
	call putstring
	jmp prompt
1:

# hurd 2
	cmpb $92,%al
	jne 1f
hurd_key:
	call newline
	movl $hurd2,%ecx
	call putstring
	jmp prompt
1:

# Menu
	cmpb $93,%al
	jne 1f
	call newline
	movl $menu,%ecx
	call putstring
	jmp prompt
1:

# GNU
	cmpb $70,%al
	jne 1f
	call newline
	movl $gnu,%ecx
	call putstring
	jmp prompt
1:

# DNF
	cmpb $69,%al
	jne 1f
	call newline
	movl $dnf,%ecx
	call putstring
loop2:
	inb $0x60,%al
	andb $0x7f,%al
	cmpb $69,%al
	je loop2
	movl $dnf2,%ecx
	call putstring
	jmp prompt
1:

# stop joking, implement really useful stuff: shifts
	movzbl %al,%eax
	movb tab(%eax),%cl
	cmpb $1,shiftl
	je shifted
	cmpb $1,shiftr
	je shifted
	jmp not_shifted
shifted:
	subb $0x20,%cl
not_shifted:

# a real char! Record it if possible
	cmpb $' ',%cl
	je  stop_record
	cmpb $COMMAND_SIZE,cmdp
	jne 1f

stop_record:
	movb $0,cmdr

1:
	cmpb $1,cmdr
	jne 1f
	movl cmdp,%eax
	movb %cl,cmd(%eax)
	addl $1,cmdp
	jmp 1f

1:
	call putchar
	jmp loop

	hlt

	.size main,.-main


/*
 * Put byte held in %cl on the screen
 */
putbyte:
	pushl %ecx
	shr $4,%cl
	call putnibble
	popl %ecx
	jmp putnibble

/*
 * Put nibble held in %cl on the screen
 */
putnibble:
	andb $0xf,%cl
	cmpb $9,%cl
	ja   hexa
	addb $'0',%cl
	jmp putchar
hexa:
	addb $('A'-10),%cl
	jmp putchar

/*
 * Put string held in %ecx on the screen
 */
putstring:
	movb (%ecx),%al
	andb %al,%al
	jnz doit
	ret
doit:
	pushl %ecx
	movb %al,%cl
	call putchar
	popl %ecx
	incl %ecx
	jmp putstring


/*
 * Put character held in %cl on the screen
 */
putchar:
	andb %cl,%cl
	jne 1f
	ret
1:
	cmpb $'\n',%cl
	jne 1f
	jmp newline
1:
	movl $VGA,%eax
	addl cur,%eax
	addl cur,%eax
	movb %cl,(%eax)
	incl X
	incl cur
	cmpl $80,X
	jae newline
	movw cur,%cx
	jmp cursor

/*
 */
newline:
	movl X,%edx
	subl %edx,cur
	addl $80,cur
	movl $0,X
	incl Y
	cmpl $24,Y
	jbe noscroll

	decl Y
	subl $80,cur
	movl $(VGA+80*2),%esi
	movl $VGA,%edi
	movl $(80*24/2),%ecx
	cld
	rep movsl
	movl $(VGA+24*80*2),%edi
	movw $0x0720,%ax
	movl $80,%ecx
	rep stosw

noscroll:
	movw cur,%cx
	jmp cursor

/*
 * Move cursor to mposition %cx
 */
cursor:
        // high
        movw $0x3d4,%dx
        movb $0xe,%al
        outb %al,%dx
        movw $0x3d5,%dx
	movb %ch,%al
        outb %al,%dx

        // low
        movw $0x3d4,%dx
        movb $0xf,%al
        outb %al,%dx
        movw $0x3d5,%dx
	movb %cl,%al
        outb %al,%dx
	ret

charA:
	.byte 65

.comm X,4
.comm Y,4
.comm cur,4
.comm lastk,1

.comm shiftl,1
.comm shiftr,1

cbf:
	.string ": Computer bought the farm\n"

help:
	.string "Help yourself and the keyboard will help you\n"
hurd:
	.string "You hit the Hurd key!\n"
hurd2:
	.string "Gratuitous error\n"
menu:
	.string "You really blew it this time\n"
gnu:
	.string "Oops, your GNU got the SPARC-HPPA combo!\n  ,           ,\n /             \\\n((__-^^-,-^^-__))\n `-_---' `---_-'\n  `--|o` 'o|--'\n     \  `  /\n      ):_:(\n      :o_o:\n       |.|\n        U \n"
dnf:
	.string "Loading Duke Nukem Forever..."
dnf2:
	.string " error: stale NFS file handle\n"

welcome:
	.string "GNU 0.401 (console)\n\nGNU 0.401 GNU-Mach 0.42/Hurd-0.401 i686-AT386 built on 2011-04-01\n\nThe programs included with the Debian GNU/Hurd system are free software;\nthe exact distribution terms for each program are described in the\nindividual files in /usr/share/doc/*/copyright.\n\nDebian GNU/Hurd comes with ABSOLUTELY NO WARRANTY, to the extent\npermitted by applicable law.\n\n"

// command buffer
.comm cmd,COMMAND_SIZE+1
.comm cmdp,4 // index
.comm cmdr,1 // still recording?

tab:
	.byte 0,  27, '1','2','3','4','5','6' /*  0 -  7 */
	.byte '7','8','9','0','-','=',0x8,0x9 /*  8 - 15 */
	.byte 'q','w','e','r','t','y','u','i' /* 16 - 23 */
	.byte 'o','p','[',']','\n', 0 ,'a','s'/* 24 - 31 */
	.byte 'd','f','g','h','j','k','l',';' /* 32 - 39 */
	.byte ''','`', 0 ,'\\','z','x','c','v'/* 40 - 47 */
	.byte 'b','n','m',',','.','/', 0 ,'*' /* 48 - 55 */
	.byte  0 ,' ', 0 , 0 , 0 , 0 , 0 , 0  /* 56 - 63 */
	.byte  0 , 0 , 0 , 0 , 0 , 0 , 0 ,'7' /* 64 - 71 */
	.byte '8','9','-','4','5','6','+','1' /* 72 - 79 */
	.byte '2','3','0','.', 0 , 0 ,'<', 0  /* 80 - 87 */
	.byte  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0  /* 88 - 95 */
	.byte  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0  /* 96 - 103 */
	.byte  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0  /* 104 - 111 */
	.byte  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0  /* 112 - 119 */
	.byte  0 , 0 , 0 , 0 , 0 , 0 , 0 , 0  /* 120 - 127 */


.comm stack,STACK_SIZE
